package nts.interf;

import java.util.List;
import java.util.Map;

import nts.interf.base.*;

/**
 * Interface for numerical transition systems (NTS).
 *
 */
public interface INTS extends IScope, IAnnotated, IVisitable {
	/**
	 * Name of the NTS.
	 */
	public String name();
	/**
	 * Initial condition (pre-condition) of the NTS. Returns 'true' expression if precondition is unspecified.
	 */
	public IExpr precondition();
	/**
	 * 
	 * @return list of subsystems
	 */
	public List<ISubsystem> subsystems();
	/**
	 * 
	 * @return map from subsystem names to number of instances
	 */
	public Map<String,IExpr> instances();
}
