package nts.interf;

import nts.interf.base.*;

/**
 * Interface for transitions of a subsystem. 
 *
 */
public interface ITransition extends IAnnotated, IVisitable {
	/**
	 * @return true iff ID was specified
	 */
	public boolean hasID();
	/**
	 * @return null if ID wasn't specified
	 */
	public String id();
	/**
	 * @return source control state
	 */
	public IControlState from();
	/**
	 * @return target control state
	 */
	public IControlState to();
	/**
	 * @return transition label
	 */
	public ILabel label();
}
