package nts.parser;

import java.util.*;

import org.antlr.runtime.Token;

import nts.interf.base.IExpr;
import nts.interf.base.IVisitor;
import nts.interf.expr.IAccessIndexed;

public class AccessIndexed extends Access implements IAccessIndexed {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	// guarantees: size >= 1
	private List<IExpr> indices = new LinkedList<IExpr>();
	
	//void setToken(Token aToken) { token(aToken); }
	public int accessDepth() { return indices.size(); }
	public int multiAccess() { return 1; }
	
	// interface
	public List<IExpr> indices() { return indices; }	
	
	
	public AccessIndexed(Token aId, List<IExpr> aI) {
		super(aId);
		indices = aI;
	}
	
	public AccessIndexed(Token aId) {
		super(aId);
	}
	
	public void setInx(List<IExpr> aI) {
		indices = aI;
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags aS) {
		
		check_base(aVT,aS);
		
		// semantic checks for indices
		SemFlags s = SemFlags.addNoPrimed(aS);
		Expr.checkInt(indices, aVT, s);
		
		return this;
	}
	
	public AccessIndexed syn_copy() {
		AccessIndexed e = new AccessIndexed(token);
		for (IExpr ee : indices) {
			e.indices.add(((Expr)ee).syn_copy());
		}
		return e;
	}
}
