package nts.parser;

import nts.interf.base.EBasicType;
import nts.interf.base.IVisitor;
import nts.interf.expr.ILitBool;

import org.antlr.runtime.Token;

public class LitBool extends Expr implements ILitBool {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	private boolean b;
	
	public boolean value() { return b; }
	
	public LitBool(Token aT, boolean aB) {
		super(aT,aT);
		b = aB;
	}
	
	public static LitBool dummyTrue() {
		return new LitBool(Common.parser.dummyTrue(),true);
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags seType) {
		type = new Type(EBasicType.BOOL);
		return this;
	}
	
	LitBool syn_copy() {
		LitBool ret = new LitBool(token, b);
		ret.b = b;
		return ret;
	}
}
